/********************************************************************
/*Name:		Shuang Xu
/*DePaul ID:	0255454
/*Course No:	SE455, Software Development Methods
/*Instructor:	Robert Stalzer
/*Project Name: Tetris
/*******************************************************************/

/*
Using STRATEGY for class LowestCell, whose subclasses implement the 
concrete algorithms of calculating the position of the LowestCell of different shapes.
*/

public interface LowestCell {
    public static final int TWELVE_OCLOCK = 1;
    public static final int THREE_OCLOCK  = 2;
    public static final int SIX_OCLOCK    = 3;
    public static final int NINE_OCLOCK   = 4;

    public abstract Cells getLowestCell(Shape s);

}

class CubeLowestCell implements LowestCell {
    protected Cells cells;
    public Cells getLowestCell(Shape s) {
	cells = new Cells(s.getRow()+1, s.getColumn(), 2);
	return cells;
    }
}

class LLowestCell implements LowestCell {
    protected Cells cells;
    public Cells getLowestCell(Shape s) {
	int curPos = s.getViewingAngle();
	if (curPos == TWELVE_OCLOCK )
		cells = new Cells(s.getRow()+1, s.getColumn(), 1);
	else if (curPos == THREE_OCLOCK )
		cells = new Cells(s.getRow()+2, s.getColumn()+1, 1);
	else if (curPos == SIX_OCLOCK )
		cells = new Cells(s.getRow()+1, s.getColumn(), 3);
	else if (curPos == NINE_OCLOCK )
		cells = new Cells(s.getRow()+2, s.getColumn(), 2);
	else 
		cells = null;
	return cells;
    }
}
	
class BackwardLLowestCell implements LowestCell {
    protected Cells cells;
    public Cells getLowestCell(Shape s) {
	int curPos = s.getViewingAngle();
	if (curPos == TWELVE_OCLOCK )
		cells = new Cells(s.getRow()+1, s.getColumn()+2, 1);
	else if (curPos == THREE_OCLOCK )
		cells = new Cells(s.getRow()+2, s.getColumn(), 2);
	else if (curPos == SIX_OCLOCK )
		cells = new Cells(s.getRow()+1, s.getColumn(), 3);
	else if (curPos == NINE_OCLOCK )
		cells = new Cells(s.getRow()+2, s.getColumn(), 1);
	else 
		cells = null;
	return cells;
    }
}	

class StairLowestCell implements LowestCell {
    protected Cells cells;
    public Cells getLowestCell(Shape s) {
	int curPos = s.getViewingAngle();
	if (curPos == TWELVE_OCLOCK ||  curPos == SIX_OCLOCK )
		cells = new Cells(s.getRow()+2, s.getColumn()+1, 1);
	else if (curPos == THREE_OCLOCK || curPos == NINE_OCLOCK )
		cells = new Cells(s.getRow()+1, s.getColumn(), 2);
	else 
		cells = null;
	return cells;
    }
}

class BackwardStairLowestCell implements LowestCell {
    protected Cells cells;
    public Cells getLowestCell(Shape s) {
	int curPos = s.getViewingAngle();
	if (curPos == TWELVE_OCLOCK ||  curPos == SIX_OCLOCK )
		cells = new Cells(s.getRow()+2, s.getColumn(), 1);
	else if (curPos == THREE_OCLOCK || curPos == NINE_OCLOCK )
		cells = new Cells(s.getRow()+1, s.getColumn()+1, 2);
	else 
		cells = null;
	return cells;
    }
}	

class TLowestCell implements LowestCell {
    protected Cells cells;
    public Cells getLowestCell(Shape s) {
	int curPos = s.getViewingAngle();
	if (curPos == TWELVE_OCLOCK )
		cells = new Cells(s.getRow()+1, s.getColumn(), 3);
	else if (curPos == THREE_OCLOCK )
		cells = new Cells(s.getRow()+2, s.getColumn(), 1);
	else if (curPos == SIX_OCLOCK )
		cells = new Cells(s.getRow()+1, s.getColumn()+1, 1);
	else if (curPos == NINE_OCLOCK )
		cells = new Cells(s.getRow()+2, s.getColumn()+1, 1);
	else 
		cells = null;
	return cells;
    }
}


class StickLowestCell implements LowestCell {
    protected Cells cells;
    public Cells getLowestCell(Shape s) {
	int curPos = s.getViewingAngle();
	if (curPos == TWELVE_OCLOCK ||  curPos == SIX_OCLOCK )
		cells = new Cells(s.getRow(), s.getColumn(), 4);
	else if (curPos == THREE_OCLOCK || curPos == NINE_OCLOCK )
		cells = new Cells(s.getRow()+3, s.getColumn(), 1);
	else 
		cells = null;
	return cells;
    }
}