/********************************************************************
/*Name:		Shuang Xu
/*DePaul ID:	0255454
/*Course No:	SE455, Software Development Methods
/*Instructor:	Robert Stalzer
/*Project Name: Tetris
/*******************************************************************/

/*	A StairShaped tetris object looks like this
			 _
			|_|_
			|_|_|
			  |_|
                                                                       
*/

import java.awt.Graphics;
import java.awt.Color;


public class StairShape 
    extends Shape
{    
    // Color of this shape. 
    protected static ShapeColorFactory colorfactory = new ShapeColorFactory(2);
    public static final Color MY_COLOR = colorfactory.Create();

    // LowestCell of this shape. 
    protected LowestCell LowCell = new StairLowestCell();

    // Filling cells at four different positions.
    protected FillingCells 	fc12 = new FillingCellsat12(this),
       				fc3 = new FillingCellsat3(this),
				fc6 = new FillingCellsat6(this),
       				fc9 = new FillingCellsat9(this);

    // Public constructor
    public StairShape()
    {
	super();
    }

    //	Return a color of this figure
    public Color getShapeColor()
    {
	return MY_COLOR;
    }

    //	Return the coordinate of the lowest cell occupied by this fugure
    // and a number of cells at same level to its right    
    public Cells getLowestCell()
    {
	return LowCell.getLowestCell(this);
    }   

    // Return all filled cells
    public FilledCells getFilledCells() 
    {
        if ( curPos == TWELVE_OCLOCK )  	return fc12.FillingStair();
        else if ( curPos == THREE_OCLOCK ) 	return fc3.FillingStair();
        else if ( curPos == SIX_OCLOCK )  	return fc6.FillingStair();
        else if ( curPos == NINE_OCLOCK )  	return fc9.FillingStair();
	return null;
    }
}